Skip to main content
`Ctrl`+`K`

# KSPMonitorSNESResidual

Prints the `SNES` residual norm, as well as the `KSP` residual norm, at each iteration of a `KSPSolve()` called within a `SNESSolve()`.

## Synopsis

    #include "petsc/private/snesimpl.h"
    PetscErrorCode KSPMonitorSNESResidual(KSP ksp, PetscInt n, PetscReal rnorm, PetscViewerAndFormat *vf)

Collective

## Input Parameters

- ksp - iterative context

- n - iteration number

- rnorm - 2-norm (preconditioned) residual value (may be estimated).

- vf - The viewer context

## Options Database Key

- -snes_monitor_ksp - Activates `KSPMonitorSNESResidual()`

## Note

This is not called directly by users, rather one calls `KSPMonitorSet()`, with this function as an argument, to cause the monitor to be used during the `KSP` solve.

## See Also

SNES: Nonlinear Solvers, `SNES`, `KSPMonitorSet()`, `KSPMonitorResidual()`, `KSPMonitorTrueResidualMaxNorm()`, `KSPMonitor()`, `SNESMonitor()`, `PetscViewerAndFormat()`

## Level

intermediate

## Location

src/snes/interface/snesut.c

Index of all SNES routines
Table of Contents for all manual pages
Index of all manual pages